#!/bin/sh
source /etc/profile

function print_usage() {
	echo "Usage: $0 <OEM_CODE(2)> <EXEC_CMD>"
}

for i in $*; do
	if [ "$i" == "-h" ]; then
		print_usage;
		exit 1
	fi
done

OFFSET="30"
OFFSET_LENGTH="2"
EXPECT_PNCODE=$1
EXEC_CMD=`echo "$*" | awk '{$1=""; print $0}' | sed -e 's/^ *//'`
PNCODE=`syft.st -r 1 | awk -F ' = ' '{printf $2}'`
CUR_OEM_CODE=`echo "${PNCODE}" | cut -c ${OFFSET}- | cut -c -$OFFSET_LENGTH`
if [ "$CUR_OEM_CODE" == "$EXPECT_PNCODE" ]; then
	EXEC_FILE=`echo $EXEC_CMD | awk '{printf $1}'`
	if [ -x $EXEC_FILE ]; then
		echo "$EXEC_CMD"
		$EXEC_CMD
	else 
		echo "[error] Can't execute $EXEC_FILE"
	fi
else
	echo "[Warn] OEM Code mismatch"
fi

