#!/bin/sh

source /etc/profile

USB_PY_DEVICE=/proc/ambarella/usbphy0

function check_sd_card() {
	det=$(ls /dev/mmcblk0 | wc -l)
	if [ $det -eq 1 ]; then
		echo "Detcted SD Card..."
		return 1
	else
		echo "Not detected SD Card..."
		return 0
	fi
}

function get_usb_hid_device() {
	/bin/echo `/usr/sbin/spcp 40 1`
}

function set_otg_mode_to_device() {
	/bin/echo device > $USB_PY_DEVICE
}

function install_g_hid_driver() {
	/sbin/modprobe g_hid
}

function install_g_hid_ms_driver() {
        /sbin/modprobe g_hid_ms file=/dev/mmcblk0p1 stall=0 removable=1
}

usb_hid_device=`get_usb_hid_device`
echo "usb_hid_device: $usb_hid_device"
if [ "$usb_hid_device" = "1" ]; then
	set_otg_mode_to_device
	install_g_hid_driver
	if [ $? -ne 0 ]; then
		echo "failed to install g_hid driver!"
	fi
elif [ "$usb_hid_device" = "5" ]; then
	set_otg_mode_to_device
	check_sd_card
	ret=$?
	if [ $ret -eq 1 ];then
		install_g_hid_ms_driver
		if [ $? -ne 0 ]; then
			echo "failed to install g_hid_ms driver!"
		fi
	else
		install_g_hid_driver
		echo "modprobe g_hid instead of g_hid_ms because No SD Card..."
	fi	
else
	echo "No PN CODE for Gadget Device..."
fi

exit 0
