#!/bin/sh

source /usr/local/bin/p2p_common.sh

function is_to_hostap() {
	local wifi_type=$1
	if [ `is_hostap_supported $wifi_type` -ne 1 ]; then
		$ECHO "0"
		return
	fi

	# if support hostap but no wlan_mode.conf file, then go to hostap
	if [ ! -f "$WLAN_MODE_CONF" ]; then
		$ECHO "1"
		return
	fi

	if [ `is_wlan_mode_hostap` -eq 1 ]; then
		$ECHO "1"
	else
		$ECHO "0"
	fi
}

WIFI_TYPE=`get_wifi_type`
$ECHO "WIFI_TYPE: $WIFI_TYPE"
WLAN_SUPPORTED=`is_wlan_supported $WIFI_TYPE`
$ECHO "WLAN_SUPPORTED: $WLAN_SUPPORTED"
if [ "$WLAN_SUPPORTED" != "1" ]; then
	$ECHO "not supoprt wlan"
	exit 0
fi

TO_HOSTAP=`is_to_hostap $WIFI_TYPE`
$ECHO "TO_HOSTAP: $TO_HOSTAP"
if [ "$TO_HOSTAP" -eq 1 ]; then
	$ECHO "[host mode]"
	pre_init_hostap
	/usr/local/bin/init_hostapd.sh -f
else
	$ECHO "[station mode]"
	/usr/local/bin/init_sta_mode.sh -f
fi

$ECHO "RT3070" > /var/log/installed_wlan
