#!/bin/sh

# Source function library.
source /usr/local/bin/ipfilter_common.sh

[ ! -f $SYIPFILTER_CONF ] && exit 0

. $SYIPFILTER_CONF

function reset_iptables() {
	eval `cleanup_filter`
}

function start_iptables() {
	local is_security_on=`get_security_option`
	if [ $is_security_on -ne 0 ]; then
		eval `filter_remote_control_services "$FILTER_REMOTE_CONTROL_IPS"`
	fi

	if [ -z $FILTER_NORMAL_SERVICES ]; then
		FILTER_NORMAL_SERVICES=ACCEPT
	fi
	eval `filter_normal_services $FILTER_NORMAL_SERVICES "$FILTER_NORMAL_IPRANGES"`
}

case "$1" in
	start)
		reset_iptables
		start_iptables
		;;
	stop)
		reset_iptables
		;;
	status)
		$IPTABLES -nvL
		;;
	restart)
		$0 start
		;;
	*)
		echo "Usage: syipfilter {start|stop|status|restart}"
		exit -1
		;;
esac

exit 0
