#!/bin/sh

source /usr/local/bin/wifi_common.sh

function set_p2p_common_env() {
	P2P_TYPE_NONE=0
	P2P_TYPE_NETTOP=1
	P2P_TYPE_NABLE=2
}

function get_p2p_type() {
	$ECHO `$SPCP 42 1`
}

function get_device_id() {
	$ECHO `$SYFTST -r 4 |$AWK -F ' = ' '{printf $2}'`
}

function get_p2p_type_script() {
	local p2p_type=`get_p2p_type`
	if [ -z $p2p_type ]; then
		return
	fi

	local p2p_type_script="p2p_${p2p_type}_common.sh"
	if [ ! -f /usr/local/bin/$p2p_type_script ]; then
		return
	fi

	$ECHO "/usr/local/bin/$p2p_type_script"
}

#####################################
# functions can be overridden in p2p_X_common.sh

function init_p2p() {
	$ECHO "init p2p by default"
}

function get_hostpad_ssid() {
	local wlan_mac=`increase_mac | $TR -d ' :'`
	$ECHO "FW_${wlan_mac:6}" | $TR -d '\n' | /usr/bin/od -t x1 -A none | $TR -d ' '
}

function get_hostapd_password() {
	$ECHO "987654321a"
}

function pre_init_hostap() {
	$ECHO "hostap has been pre-initialized."
}
#
#####################################

set_p2p_common_env
# source p2p type script
P2P_TYPE_SCRIPT=`get_p2p_type_script`
if [ ! -z $P2P_TYPE_SCRIPT ]; then
	source $P2P_TYPE_SCRIPT
fi
